/////////////////////////////////////////////////
//	imgctl.as (imgctl.hpi import file)
//		for imgctl.hpi version 1.26
//		by ruche.
/////////////////////////////////////////////////

#define IMGCTL_VERSION			126
#define IMGCTL_BETA				0
#define IMGCTL_VERSION_STRING	"1.26"

/////////////////////////////////////////////////

#ifndef IMGCTL_PARAMETER_NOTUSE

// BITMAPINFOHEADER parameters
#define M_BIWIDTH			0
#define M_BIHEIGHT			1
#define M_BIBITCOUNT		2
#define M_BICOMPRESSION		3
#define M_BISIZEIMAGE		4
#define M_BIXPELSPERMETER	5
#define M_BIYPELSPERMETER	6
#define M_BICLRUSED			7
#define M_BICLRIMPORTANT	8

// PNGOPT parameters
#define M_POFLAG			0
#define M_POCOMPLEVEL		1
#define M_POFILTER			2
#define M_POGAMMA			3
#define M_POCLRTRANS		4
#define M_POCLRBACK			5

// GIFOPT parameters
#define M_GOFLAG			0
#define M_GOCLRTRANS		1
#define M_GOCLRBACK			2
#define M_GOLOGWIDTH		3
#define M_GOLOGHEIGHT		4
#define M_GOLOGLEFT			5
#define M_GOLOGTOP			6
#define M_GOLZWCOUNT		7
#define M_GOBITCOUNT		8

#endif	// !IMGCTL_PARAMETER_NOTUSE

/////////////////////////////////////////////////

#ifndef IMGCTL_DEFINE_NOTUSE

// BITMAPINFOHEADER compression types
#define BI_RGB				0			// k
#define BI_RLE8				1			// 8rbgRLE
#define BI_RLE4				2			// 4rbgRLE
#define BI_BITFIELDS		3			// rbgtB[h

// Raster operations
#define ROP_BLACKNESS		$000042		// BLACK
#define ROP_DSTINVERT		$550009		// !dest
#define ROP_MERGECOPY		$C000CA		// src & pat
#define ROP_MERGEPAINT		$BB0226		// !src | dest
#define ROP_NOTSRCCOPY		$330008		// !src
#define ROP_NOTSRCERASE		$1100A6		// !src & !dest
#define ROP_PATCOPY			$F00021		// pat
#define ROP_PATINVERT		$5A0049		// pat ^ dest
#define ROP_PATPAINT		$FB0A09		// (!src | pat) | dest
#define ROP_SRCAND			$8800C6		// src & dest
#define ROP_SRCCOPY			$CC0020		// src
#define ROP_SRCERASE		$440328		// src & !dest
#define ROP_SRCINVERT		$660046		// src ^ dest
#define ROP_SRCPAINT		$EE0086		// src | dest
#define ROP_WHITENESS		$FF0062		// WHITE

// Stretch modes
#define SBM_BLACKONWHITE	1
#define SBM_WHITEONBLACK	2
#define SBM_COLORONCOLOR	3
#define SBM_HALFTONE		4

// Paste procedure ids
#define PP_DEFAULT			0			// ftHg
#define PP_ALPHA			1			// At@ufBO
#define PP_SPRITE			2			// XvCg(F)
#define PP_FRAME			3			// t[At@
#define PP_PNGALPHA			4			// PNG̃At@`l

// PNGOPT flags
#define POF_COMPLEVEL		$000001		// kg
#define POF_FILTER			$000002		// tB^g/擾
#define POF_GAMMA			$000004		// K}␳g/擾
#define POF_TRNSCOLOR		$000008		// Fg/擾
#define POF_BACKCOLOR		$000010		// wiFg/擾
#define POF_TEXT			$000020		// eLXgg
#define POF_TEXTCOMP		$000040		// eLXgks
#define POF_INTERLACING		$000080		// C^[[Xɂ/ł
#define POF_TIME			$000100		// ŏIXVԂۑ
#define POF_BACKPALETTE		$010000		// wiF̎w/擾Ƀpbgԍg(1,4,8Bit)
#define POF_TRNSPALETTE		$020000		// F̎w/擾Ƀpbgԍg(1,4,8Bit)
#define POF_TRNSALPHA		$040000		// F̎w/擾ɓߏ\̂g(1,4,8Bit)

// PNGOPT filters
#define PO_FILTER_NONE		$000008		// tB^KpȂ
#define PO_FILTER_SUB		$000010		// ̃sNZ̍
#define PO_FILTER_UP		$000020		// ̃sNZ̍
#define PO_FILTER_AVG		$000040		// Ə̃sNZ̗\Ƃ̍
#define PO_FILTER_PAETH		$000080		// Əƍ̃sNZ̗\Ƃ̍

// Populer gammas for PNGOPT
#define PO_GAMMA_NORMAL		45455		// (1.0/2.2)*100000
#define PO_GAMMA_WIN		PO_GAMMA_NORMAL
#define PO_GAMMA_MAC		55556		// (1.0/1.8)*100000

// GIFOPT flags
#define GOF_LOGICAL			$000001		// _ʏg/
#define GOF_TRNSCOLOR		$000008		// Fg
#define GOF_BACKCOLOR		$000010		// wiFg
#define GOF_INTERLACING		$000080		// C^[[Xɂ/ł
#define GOF_BACKPALETTE		$010000		// wiF̎w/擾Ƀpbgԍg
#define GOF_TRNSPALETTE		$020000		// F̎w/擾Ƀpbgԍg
#define GOF_LZWCLRCOUNT		$080000		// NAJEgw肷
#define GOF_LZWNOTUSE		$100000		// LZWksȂ(kGIF)
#define GOF_BITCOUNT		$200000		// /ǂݍݎ̍ŏrbgw肷

// Image types
#define IMG_ERROR			$FFFFFF		// v1.12B9
#define IMG_UNKNOWN			$000000
#define IMG_BMP				$000001
#define IMG_BITMAP			IMG_BMP
#define IMG_DIB				IMG_BMP
#define IMG_RLE				IMG_BMP
#define IMG_JPEG			$000002
#define IMG_JPE				IMG_JPEG
#define IMG_JPG				IMG_JPEG
#define IMG_EXIF			IMG_JPEG	// v1.10B4
#define IMG_PNG				$000003
#define IMG_GIF				$000004
#define IMG_TIFF			$000005
#define IMG_TIF				IMG_TIFF
#define IMG_PIC				$000006
#define IMG_MAG				$000007
#define IMG_MAKI			IMG_MAG
#define IMG_PCX				$000008

// Enough buffer size [v1.16B3]
#define BUFSIZE_ENOUGH		(-1)

// Bitfield types
#define RGB555_R			$007C00
#define RGB555_G			$0003E0
#define RGB555_B			$00001F
#define RGB565_R			$00F800
#define RGB565_G			$0007E0
#define RGB565_B			$00001F
#define RGB888_R			$FF0000
#define RGB888_G			$00FF00
#define RGB888_B			$0000FF

// Types for ic_DIBto16BitEx & DIBto8Bit [v1.10B4]
#define TOBIT_DEFAULT		$000000
#define TOBIT_ORG			$100000		// v1.10
#define TOBIT_DIFF			$000001
#define TOBIT_DIFFFS		$000002		// v1.10B5 default
#define TOBIT_DIFFJJN		$000003		// v1.10B5
#define TOBIT_DIFFX			$000101		// v1.10B7
#define TOBIT_DIFFXFS		$000102		// v1.10B7
#define TOBIT_DIFFXJJN		$000103		// v1.10B7
#define TOBIT_DIFFDX		$000201		// v1.10B8
#define TOBIT_DIFFDXFS		$000202		// v1.10B8
#define TOBIT_DIFFDXJJN		$000203		// v1.10B8

// Flags for ic_DIBto8Bit
#define TO8_DIV_RGB			$000000
#define TO8_DIV_LIGHT		$000001
#define TO8_SEL_CENTER		$000000
#define TO8_SEL_AVGRGB		$000100
#define TO8_SEL_AVGPIX		$000200
#define TO8_PUT_RGB			$000000
#define TO8_PUT_LIGHT		$010000
#define TO8_PUT_YUV			$020000

// Resize flags [v1.12B]
#define RESZ_SAME			0			// ̂܂
#define RESZ_RATIO			(-1)		// c𑵂

// Replace colors
#define REP_R				0
#define REP_RED				REP_R
#define REP_G				1
#define REP_GREEN			REP_G
#define REP_B				2
#define REP_BLUE			REP_B

// Turn types
#define TURN_90				90
#define TURN_180			180
#define TURN_270			270

// Error codes
#define ICERR_NONE			$000000
#define ICERR_FILE_OPEN		$010001
#define ICERR_FILE_READ		$010002
#define ICERR_FILE_WRITE	$010003
#define ICERR_FILE_TYPE		$010004
#define ICERR_FILE_NULL		$010005
#define ICERR_FILE_SEEK		$010006		// v1.13B4
#define ICERR_FILE_SIZE		$010007		// v1.16B3
#define ICERR_PARAM_NULL	$020001
#define ICERR_PARAM_SIZE	$020002
#define ICERR_PARAM_TYPE	$020003
#define ICERR_PARAM_RANGE	$020004		// v1.13
#define ICERR_MEM_ALLOC		$030001
#define ICERR_MEM_SIZE		$030002		// v1.16B3
#define ICERR_IMG_COMPRESS	$040001
#define ICERR_IMG_RLESIZE	$040002
#define ICERR_IMG_BITCOUNT	$040003		// v1.12B3
#define ICERR_IMG_AREA		$040004		// v1.12B3
#define ICERR_IMG_RLETOP	$040005		// v1.12B3
#define ICERR_DIB_RLECOMP	$050001
#define ICERR_DIB_RLEEXP	$050002
#define ICERR_DIB_RLEBIT	$050003
#define ICERR_DIB_NULL		$050004
#define ICERR_DIB_UPPER16	$050005
#define ICERR_DIB_AREAOUT	$050006		// v1.10B
#define ICERR_BMP_FILEHEAD	$060001
#define ICERR_BMP_HEADSIZE	$060002
#define ICERR_BMP_IMGSIZE	$060003
#define ICERR_BMP_COMPRESS	$060004
#define ICERR_RLE_TOPDOWN	$070001
#define ICERR_RLE_DATASIZE	$070002
#define ICERR_JPEG_LIBERR	$080001
#define ICERR_PNG_LIBERR	$090001
#define ICERR_PNG_NOALPHA	$090002		// v1.12B5
#define ICERR_GIF_FILEHEAD	$0B0001		// v1.13B4
#define ICERR_GIF_BLOCK		$0B0002		// v1.13B4
#define ICERR_API_STRETCH	$0A0001
#define ICERR_API_SETMODE	$0A0002
#define ICERR_API_SECTION	$0A0003
#define ICERR_API_COMDC		$0A0004
#define ICERR_API_SELOBJ	$0A0005
#define ICERR_API_BITBLT	$0A0006

#endif	// IMGCTL_DEFINE_NOTUSE

/////////////////////////////////////////////////

#uselib "imgctl.hpi"

// Standard functions
#func ic_ImgctlVersion		ic_ImgctlVersion	$202
#func ic_ImgctlBeta			ic_ImgctlBeta		$202
#func ic_ImgctlError		ic_ImgctlError		$202
#func ic_ImgctlErrorClear	ic_ImgctlErrorClear	$202
#func ic_PointerOf			ic_PointerOf		$202
#func ic_GetImageType		ic_GetImageType		$202
#func ic_GetImageMType		ic_GetImageMType	$202
#func ic_ToDIB				ic_ToDIB			$202	// Get HDIB
#func ic_MtoDIB				ic_MtoDIB			$202	// Get HDIB

// DIB functions
#func ic_DeleteDIB			ic_DeleteDIB		$202
#func ic_HeadDIB			ic_HeadDIB			$202
#func ic_PaletteDIB			ic_PaletteDIB		$202
#func ic_PixelDIB			ic_PixelDIB			$202
#func ic_ColorDIB			ic_ColorDIB			$202
#func ic_GetDIB				ic_GetDIB			$202
#func ic_CreateDIB			ic_CreateDIB		$202	// Get HDIB
#func ic_CopyDIB			ic_CopyDIB			$202	// Get HDIB
#func ic_CutDIB				ic_CutDIB			$202	// Get HDIB
#func ic_TurnDIB			ic_TurnDIB			$202
#func ic_DIBto24Bit			ic_DIBto24Bit		$202
#func ic_DIBto16Bit			ic_DIBto16Bit		$202
#func ic_DIBto16BitEx		ic_DIBto16BitEx		$202
#func ic_DIBto8Bit			ic_DIBto8Bit		$202
// 24Bit DIB functions
#func ic_PasteDIB			ic_PasteDIB			$202
#func ic_ResizeDIB			ic_ResizeDIB		$202
#func ic_TurnDIBex			ic_TurnDIBex		$202

// RLE-DIB functions
#func ic_IsRLE				ic_IsRLE			$202
#func ic_DIBtoRLE			ic_DIBtoRLE			$202
#func ic_RLEtoDIB			ic_RLEtoDIB			$202

// Bitmap functions
#func ic_DIBtoBMP			ic_DIBtoBMP			$202
#func ic_BMPtoDIB			ic_BMPtoDIB			$202	// Get HDIB
#func ic_BMPMtoDIB			ic_BMPMtoDIB		$202	// Get HDIB

// JPEG functions
#func ic_DIBtoJPG			ic_DIBtoJPG			$202
#func ic_JPGtoDIB			ic_JPGtoDIB			$202	// Get HDIB
#func ic_JPGMtoDIB			ic_JPGMtoDIB		$202	// Get HDIB

// PNG functions
#func ic_DIBtoPNG			ic_DIBtoPNG			$202
#func ic_DIBtoPNGex			ic_DIBtoPNGex		$202
#func ic_PNGtoDIB			ic_PNGtoDIB			$202	// Get HDIB
#func ic_PNGMtoDIB			ic_PNGMtoDIB		$202	// Get HDIB
#func ic_PNGAtoDIB			ic_PNGAtoDIB		$202	// Get HDIB
#func ic_PNGMAtoDIB			ic_PNGMAtoDIB		$202	// Get HDIB
#func ic_InfoPNG			ic_InfoPNG			$202
#func ic_InfoPNGM			ic_InfoPNGM			$202

// GIF functions
#func ic_DIBtoGIF			ic_DIBtoGIF			$202
#func ic_DIBtoGIFex			ic_DIBtoGIFex		$202
#func ic_DIBtoGIFAni		ic_DIBtoGIFAni		$202
#func ic_DIBtoGIFAniEx		ic_DIBtoGIFAniEx	$202
#func ic_GIFtoDIB			ic_GIFtoDIB			$202	// Get HDIB
#func ic_GIFMtoDIB			ic_GIFMtoDIB		$202	// Get HDIB
#func ic_GIFtoDIBex			ic_GIFtoDIBex		$202	// Get HDIB
#func ic_GIFMtoDIBex		ic_GIFMtoDIBex		$202	// Get HDIB

// Filter functions
#func ic_GrayDIB			ic_GrayDIB			$202
#func ic_ReplaceDIB			ic_ReplaceDIB		$202
#func ic_RepaintDIB			ic_RepaintDIB		$202
#func ic_TableDIB			ic_TableDIB			$202
// Convert table functions
#func ic_ToneDIB			ic_ToneDIB			$202
#func ic_ShadeDIB			ic_ShadeDIB			$202
#func ic_GammaDIB			ic_GammaDIB			$202
#func ic_ContrastDIB		ic_ContrastDIB		$202

// Device context functions
#func ic_DIBtoDC			ic_DIBtoDC			$202
#func ic_DIBtoDCex			ic_DIBtoDCex		$202
#func ic_DIBtoDCex2			ic_DIBtoDCex2		$202
#func ic_DCtoDIB			ic_DCtoDIB			$202	// Get HDIB

/////////////////////////////////////////////////
// EOF